/*******************************************************************************
!#                              INTEL CONFIDENTIAL
!#
!#  Copyright 2010-2013 Intel Corporation All Rights Reserved.
!#
!#  The  source code  contained  or  described herein and all documents related
!#  related to the source code  ("Material")  are  owned by  Intel  Corporation
!#  or  its  suppliers  or  licensors.  Title  to  the  Material  remains  with
!#  Intel Corporation or its suppliers and licensors. The  Material may contain
!#  trade secrets  and  proprietary   and   confidential information  of  Intel
!#  or its  suppliers  and  licensors, and is protected by  worldwide copyright
!#  and  trade secret laws  and  treaty  provisions.  No  part of the  Material
!#  may used,   copied,  reproduced,  modified,  published,  uploaded,  posted,
!#  transmitted,  distributed,  or disclosed in any way without  Intel's  prior
!#  express written permission. No license under any  patent,  copyright, trade
!#  secret or other intellectual property right is granted to or conferred upon
!#  you  by  disclosure  or  delivery of the  Materials,  either  expressly, by
!#  implication, inducement,  estoppel or otherwise.  Any  license  under  such
!#  intellectual  property  rights must be express and  approved  by  Intel  in
!#  writing.
!#
!#  Unless otherwise  agreed  by  Intel in writing, you may not remove or alter
!#  this notice or any other notice embedded in  Materials  by Intel or Intel's
!#  suppliers or licensors in any way.
!#
!#*****************************************************************************/
#include "multiply.h"

void matvec(unsigned int rows, unsigned int cols,
            FTYPE a[][cols],
            FTYPE b[restrict rows],
            FTYPE x[cols])
{
    int i, j;
    enum { inc_i = 1, inc_j = 1 };

    for (i = 0; i < rows; i += inc_i) {
        for (j = 0; j < cols; j += inc_j) {
            b[i] += a[i][j] * x[j];
        }
    }
}
